#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16
__hugeflash extern const unsigned short __checksum;

extern unsigned short slow_crc16(unsigned short,unsigned char __hugeflash *,unsigned long);
extern unsigned short fast_crc16(unsigned short,unsigned char __hugeflash *,unsigned long);

__hugeflash const int zero=0;


void main(void)
{
     unsigned short sum=0;

    /* on the Atmel AVR we can assume, that Flash begins at 0 (because of */
    /* the reset vector). Additionally we assume can that CRC ends just */
    /* before the segment CHECKSUM (because the IAR .xcl files places */
    /* this segment in the uppermost bytes of the available flash). */
#ifdef SLOW_CRC16
     sum = slow_crc16(sum,(unsigned char __hugeflash *)0, (unsigned long)&__checksum);
     sum = slow_crc16(sum,(unsigned char __hugeflash *)&zero,2);
#elif defined FAST_CRC16
     sum = fast_crc16(sum,(unsigned char __hugeflash *)0, (unsigned long)&__checksum);
#endif

     if(sum != __checksum)
          printf("***Checksum failed: %hx instead of %hx!***\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");

}
